/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/




#ifndef AQDB_CACHE_H
#define AQDB_CACHE_H

#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_object.h>

#include <gwenhywfar/list1.h>
#include <gwenhywfar/list2.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef struct AQDB_CACHE AQDB_CACHE;
GWEN_LIST_FUNCTION_LIB_DEFS(AQDB_CACHE, AQDB_Cache, AQDB_API)
GWEN_LIST2_FUNCTION_LIB_DEFS(AQDB_CACHE, AQDB_Cache, AQDB_API)


AQDB_API
AQDB_CACHE *AQDB_Cache_new(uint32_t maxEntries, uint32_t maxSize);

AQDB_API
void AQDB_Cache_Attach(AQDB_CACHE *cache);

AQDB_API
void AQDB_Cache_free(AQDB_CACHE *cache);



AQDB_API
int AQDB_Cache_GetObject(AQDB_CACHE *cache,
                         AQDB_ID tableId,
                         AQDB_ID objectId,
                         AQDB_OBJECT **pObject);

AQDB_API
int AQDB_Cache_SetObject(AQDB_CACHE *cache, const AQDB_OBJECT *object, uint32_t osize);

AQDB_API
void AQDB_Cache_PurgeObject(AQDB_CACHE *cache, AQDB_ID tableId, AQDB_ID objectId);



#ifdef __cplusplus
}
#endif


#endif

