/****************************************************************************
 * This file is part of the project AqDatabase.
 * AqDatabase (c) by 2016 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef AQDB_QUERY_RESULT_H
#define AQDB_QUERY_RESULT_H

#include <aqdatabase/aqdb.h>
#include <gwenhywfar/list1.h>
#include <gwenhywfar/idlist64.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef struct AQDB_QUERY_RESULT AQDB_QUERY_RESULT;


GWEN_LIST_FUNCTION_LIB_DEFS(AQDB_QUERY_RESULT, AQDB_QueryResult, AQDB_API)


AQDB_API AQDB_QUERY_RESULT *AQDB_QueryResult_new(AQDB_ID qid);
AQDB_API void AQDB_QueryResult_free(AQDB_QUERY_RESULT *qr);

AQDB_API AQDB_ID AQDB_QueryResult_GetQueryId(const AQDB_QUERY_RESULT *qr);
AQDB_API void AQDB_QueryResult_AddId(AQDB_QUERY_RESULT *qr, AQDB_ID id);
AQDB_API int AQDB_QueryResult_GetFirstIds(AQDB_QUERY_RESULT *qr,
                                          AQDB_ID *idListPtr,
                                          int *idListLen);
AQDB_API int AQDB_QueryResult_GetNextIds(AQDB_QUERY_RESULT *qr,
                                         AQDB_ID *idListPtr,
                                         int *idListLen);

AQDB_API GWEN_IDLIST64 *AQDB_QueryResult_GetIdList(const AQDB_QUERY_RESULT *qr);
AQDB_API void AQDB_QueryResult_SetIdList(AQDB_QUERY_RESULT *qr, GWEN_IDLIST64 *idl);



AQDB_API AQDB_QUERY_RESULT *AQDB_QueryResult_List_GetById(AQDB_QUERY_RESULT_LIST *qrl, AQDB_ID id);



#ifdef __cplusplus
}
#endif


#endif



